{****************************************************************************

                   Copyright (c) 1993,94 by Florian Klmpfl

 ****************************************************************************}

unit globals;

  interface

    uses
       cobjects,dos,strings
{$ifdef tp}
,objects
{$endif tp}
	;

    const
       { Versionsstring }
       version = '0.2pl.5';

       { Signifikante ID-Lnge }
       maxidlen = 64;
       maxinputlen = 10000;

    type
       { Puffer fr die Eingabe}
       tinputbuffer = array[0..maxinputlen] of char;

       pinputbuffer = ^tinputbuffer;

       pinputstack = ^tinputstack;

       tinputstack = record
          filenotatend : boolean;
          f : file;
          buffersize : word;
          inputbuffer : pinputbuffer;
          inputpointer : word;
          filename : cobjects.pstring;
          line_no : longint;
          next : pinputstack;
       end;

       { Fehlerkonstanten }

       errorconst = (endoffile,
                     dupid,
                     syntax_error,
                     out_of_mem,
                     unknown_id,
                     ill_character,
                     too_long_source,
                     inline_not_supported,
                     near_ignored,
                     far_ignored,
                     interrupt_ignored,
                     priv_meth_not_virtual,
                     const_cannot_priv,
                     dest_cannot_priv,
                     id_not_found,
                     no_local_objects,
                     no_anonym_objects,
                     type_id_expect,
                     id_already_type,
                     type_id_not_defined,
                     error_in_type,
                     statement_expect,
                     error_in_integer,
                     error_in_expression,
                     type_mismatch,
                     too_complex_expr,
                     continue_not_allowed,
                     break_not_allowed,
                     exceptions_not_allowed,
                     invalid_qualifizier,
                     invalid_for_var,
                     ordinal_expect,
                     upper_l_lower,
                     ill_unit_name,
                     malformed_unit,
                     error_reading_unit,
                     rec_unit_def,
                     too_much_units,
                     ill_char_const,
                     overloaded_no_proc,
                     same_parameters,
                     no_para_match,
                     too_much_matches,
                     proc_must_handleexceptions,
                     forward_not_resolved,
                     cannot_open_input,
                     header_dont_match,
                     ill_field,
                     para_too_big,
                     too_much_lexlevel,
                     ill_switch,
                     cannot_open_incfile,
                     type_must_be_rec_or_class,
                     unit_not_found,
                     dup_enum,
                     pointer_expect,
                     not_same_target,
                     type_const_not_possible,
                     double_caselabel,
                     range_check_error,
                     ill_type_cast,
                     class_type_expect,
                     no_overloaded_procvars,
                     cannot_open_asmfile,
                     string_too_long,
                     object_type_expect,
                     method_id_expect,
                     header_dont_match_any_member,
                     take_extended_syntax,
                     file_must_call_by_referenz,
                     string_exceed_line,
                     ill_unit_version,
                     error_in_real,
                     no_paras_2_destructor,
                     fail_only_in_constructor,
                     only_pack_records_,
                     too_much_endifs,
                     endif_expect,
                     var_must_be_referenz,
                     def_only_in_program,
                     overloaded_are_not_both_virtual,
                     ol_meths_not_same_ret,
                     overloaded_support_exceptions_false,
                     dont_call_exported_direct,
                     dont_nest_export,
                     methods_dont_be_export,
                     self_not_in_method,
                     call_by_ref_without_typeconv);

       { Zielbetriebssysteme }

       ttarget = (target_DOS,target_OS2,target_LINUX,target_WIN32);

       stringid = string[maxidlen];

       pdouble = ^double;

    var
       inputdir : string[80];
       inputfile : string;
       objext : string[4]; { Dateierweiterung der Objektdatei }
       asmname : string;
       asmfile : file;
       makefile : text;
       linkresponse : text;
       writeasmfile,quiet : boolean;
       warnings : boolean;
       compilesystem : boolean;
       rangechecking : boolean;
       exprlevel : byte;
       gen_makefile : boolean;

       { Zielbetriebssystem }
       target : ttarget;

       { Lnge der Quelltextes }
       sourcesize : longint;

       { Codegeneratoroptionen: }
       check_overflow,genexceptcode : boolean;

       { Optimiereroptionen }
       maxoptimieren,omitstackframe,littlesize,optimiere : boolean;

       debuginfo : boolean;        { true, wenn Debuggerinformationen }
                                   { erzeugt werden sollen            }

       unitpath : dirstr;          { Pfad zur PP.EXE um PPU-Dateien   }
                                   { in diesem Verzeichnis suchen zu  }
                                   { koennen                          }
       inputstack : pinputstack;

       abslines : longint;         { Anzahl der wirklich uebersetzten Zeilen }
       exterror : pchar;           { erweiterte Informationen ueber einen Fehler }

       codegeneration : boolean;   { wird auf false gesetzt wenn einfacher   }
                                   { Fehler auftritt und damit keine Ausgabe }
                                   { erfolgen soll                           }

       errorcount : word;          { Anzahl der aufgetretenen Fehler }
{$ifdef TP}
       use_big : boolean;          { true, wenn die "groe"-Compilerversion }
                                   { gewhlt werden soll, mit EMS-Nutzung   }
       symbolstream : temsstream;  { EMS-Stream, in welchem bei use_big=true  }
                                   { die Symbole abgelegt werden              }
{$endif}
       errorlev : boolean;         { ist errorlev true, dann gibt der Compiler, }
                                   { am Ende wenn eine Unit bersetzt wurde,    }
                                   { 255 zurck                                 }

       { Zeilennummer der momentanen Befehlzeile }
       aktlinenr : longint;

       packrecords : word;         { Ausrichtung von Records (nur 1 oder 2)}

       gendeffile  : boolean;      { true, wenn eine DEF-Datei erzeugt werden soll }
       genpm : boolean;            { true, wenn in DEF-Datei WINDOWAPI angegeben werden soll }
       description : string;       { gibt die Beschreibung in der DEF-Datei an     }
       defdatei : text;            { Textdatei fr DEF-Datei }


    procedure warning(w : errorconst);
    procedure error(w : errorconst);
    procedure fatalerror(w : errorconst);
    procedure internalerror(i : integer);
    function upper(const s : string) : string;
    procedure uppervar(var s : string);
    function tostr(i : longint) : string;
    function gettmpname : string;
    procedure globalsinit;
    procedure funcnotimpl(const s : string);
    function ibm2ascii(const s : string) : string;
    function double2str(d : double) : string;
    procedure setstring(var p : pchar;const s : string);

    function min(a,b : longint) : longint;
    function max(a,b : longint) : longint;

    { sucht Datei mit Namen f in den in path angegebenen Verzeichnissen }
    function search(const f : string;path : string;var b : boolean) : string;

    {$ifdef debug}
    function assigned(p : pointer) : boolean;
    {$endif}

  implementation

  {$ifdef debug}

    function assigned(p : pointer) : boolean;

      var
         lp : longint;

      begin
         lp:=longint(seg(p^))*16+longint(ofs(p^));
         if (lp<>0) and
            ((lp<longint(seg(heaporg^))*16+longint(ofs(heaporg^))) or
            (lp>longint(seg(heapptr^))*16+longint(ofs(heapptr^)))) then
           runerror(230);
         assigned:=lp<>0;
      end;

  {$endif}

    function min(a,b : longint) : longint;

      begin
         if a>b then
           min:=b
         else min:=a;
      end;

    function max(a,b : longint) : longint;

      begin
         if a<b then
           max:=b
         else max:=a;
      end;

    var
       tmpname : longint;

    function geterrormsg(i : integer) : string;

      var
         t : text;
         s : string;

      begin
         assign(t,unitpath+'ERROR.MSG');
{$ifdef tp}         
         {$i-}
{$endif}
         reset(t);
{$ifdef tp}         
         {$i+}
{$endif}
         if ioresult<>0 then
           begin
              writeln('Fehler.');
              writeln('**** Fehlertextdatei ERROR.MSG nicht gefunden. *****');
              halt(1);
           end;
         for i:=i downto 0 do
           readln(t,s);
         close(t);
         geterrormsg:=s;
      end;

    function ibm2ascii(const s : string) : string;

      var
         i : integer;
         hs : string;
         b : byte;

      begin
         hs:='';
         for i:=1 to length(s) do
           if ((ord(s[i])>127) or (ord(s[i])<32)) or (s[i]='"') then
             begin
                b:=ord(s[i]);
                hs:=hs+'\'+tostr(b div 64);
                b:=b mod 64;
                hs:=hs+tostr(b div 8);
                b:=b mod 8;
                hs:=hs+tostr(b);
                if (i<length(s)) and
                  (ord(s[i+1])>=48) and  (ord(s[i+1])<=57) then
                  hs:=hs+'"'#13#10#9'.ascii "';
             end
           else if s[i]='\' then
             hs:=hs+'\\'
           else hs:=hs+s[i];
         ibm2ascii:=hs;
      end;

    function double2str(d : double) : string;

      var
         hs : string;

      begin
         str(d,hs);
{$ifdef tp}
         { TP fgt am Anfang ein Leerzeichen ein, dieses entfernen }
         delete(hs,1,1);
{$endif}
         double2str:='0d'+hs;
      end;

    function gettmpname : string;

      begin
         gettmpname:='T$$'+tostr(tmpname);
      end;

    procedure funcnotimpl(const s : string);

      begin
         writeln(upper(inputstack^.filename^),'(',inputstack^.line_no,'): ','Nicht komplett implementiert: ',s);
         halt(1);
      end;

    procedure warning(w : errorconst);

      begin
         write('?  ',upper(inputstack^.filename^),'(',inputstack^.line_no,'): ',geterrormsg(longint(w)));
         if exterror<>nil then
           begin
              write(' ',exterror);
              strdispose(exterror);
              exterror:=nil;
           end;
         writeln;
      end;

    procedure error(w : errorconst);

      begin
         inc(errorcount);
         write('!  ',upper(inputstack^.filename^),'(',inputstack^.line_no,'): ',geterrormsg(longint(w)));
         if exterror<>nil then
           begin
              write(' ',exterror);
              strdispose(exterror);
              exterror:=nil;
           end;
         writeln;
         codegeneration:=false;
         { mehr als 50 Fehler auszugeben ist wohl sinnlos }
         if errorcount>50 then halt(1);
      end;

    procedure fatalerror(w : errorconst);

      begin
         write('!! ',upper(inputstack^.filename^),'(',inputstack^.line_no,'): ',geterrormsg(longint(w)));
         if exterror<>nil then
           begin
              write(' ',exterror);
              strdispose(exterror);
              exterror:=nil;
           end;
         writeln;
         halt(1);
      end;

    procedure internalerror(i : integer);

      begin
         if not(quiet) then writeln;
         writeln(upper(inputstack^.filename^),'(',inputstack^.line_no,'): Interner Fehler ',i);
         halt(1);
      end;

    function upper(const s : string) : string;

      var i : integer;
          hs : string;

      begin
         hs:='';
         for i:=1 to length(s) do
  	   hs:=hs+upcase(s[i]);
  	 upper:=hs;
      end;

    procedure uppervar(var s : string);

      var
         i : integer;

      begin
         for i:=1 to length(s) do
           s[i]:=upcase(s[i]);
      end;

   function tostr(i : longint) : string;

     var hs : string;

     begin
        str(i,hs);
        tostr:=hs;
     end;

   procedure setstring(var p : pchar;const s : string);

     begin
{$ifdef TP}
        if use_big then
          begin
             p:=pchar(symbolstream.getpos);
             symbolstream.writestr(@s);
          end
        else
{$endif TP}
          p:=strpnew(s);
     end;

   function search(const f : string;path : string;var b : boolean) : string;

     var
        dirinfo : searchrec;
        singlepasstring : string;
        start,pos : byte;

     begin
        start:=1;
        b:=true;
        repeat
          pos:=system.pos(';',path);
          if pos=0 then
            pos:=length(path)+1;
          singlepasstring:=copy(path,start,pos-start);
          delete(path,start,pos-start+1);
          findfirst(singlepasstring+'\'+f,anyfile,dirinfo);
          if doserror=0 then
            begin
               search:=singlepasstring+'\';
               exit;
            end;
        until path='';
        b:=false;
     end;

   procedure globalsinit;

     begin
        tmpname:=0;
        writeasmfile:=false;
        quiet:=true;
        warnings:=true;
        compilesystem:=false;
        check_overflow:=false;
        omitstackframe:=false;
        optimiere:=false;
        maxoptimieren:=false;
        genexceptcode:=true;
        littlesize:=false;
        debuginfo:=false;
        exprlevel:=1;
        rangechecking:=false;
        gen_makefile:=false;
        target:=target_DOS;
        abslines:=1;
        aktlinenr:=0;
        exterror:=nil;
        codegeneration:=true;
        errorcount:=0;
{$ifdef tp}
        use_big:=false;
{$endif tp}
        errorlev:=false;
        gendeffile:=false;
        genpm:=false;
        description:='Compiled by FPKPascal';
     end;

end.
